basement-0.0.16: Foundation scrap box of array & string

License | BSD-style
Maintainer | Nicolas Di Prima <nicolas@primetype.co.uk>
Stability | stable
Portability | portable
Safe Haskell | None
Language | Haskell2010

Basement.These

Description

`These a b`, sum type to represent either `a` or `b` or both.

Synopsis

- data These a b
  - = This a
  - | That b
  - | These a b

# Documentation

data These a b #

Either a or b or both.

Constructors

This a |
That b |
These a b |

#### Instances

Instances details

(NormalForm a, NormalForm b) => NormalForm (These a b) # |
Instance details Defined in Basement.These Methods toNormalForm :: These a b -> () #
(Show a, Show b) => Show (These a b) # |
Instance details Defined in Basement.These Methods showsPrec :: Int -> These a b -> ShowS # show :: These a b -> String # showList :: [These a b] -> ShowS #
(Eq a, Eq b) => Eq (These a b) # |
Instance details Defined in Basement.These Methods (==) :: These a b -> These a b -> Bool # (/=) :: These a b -> These a b -> Bool #
(Ord a, Ord b) => Ord (These a b) # |
Instance details Defined in Basement.These Methods compare :: These a b -> These a b -> Ordering # (<) :: These a b -> These a b -> Bool # (<=) :: These a b -> These a b -> Bool # (>) :: These a b -> These a b -> Bool # (>=) :: These a b -> These a b -> Bool # max :: These a b -> These a b -> These a b # min :: These a b -> These a b -> These a b #
From (Either a b) (These a b) # |
Instance details Defined in Basement.From Methods from :: Either a b -> These a b #